;;; -*- TI-Asm -*-
;;;
;;; Flashbook Reader code
;;;
;;; Copyright (C) 2008-2010 Benjamin Moody
;;;
;;; Permission is hereby granted, free of charge, to any person
;;; obtaining a copy of this software and associated documentation
;;; files (the "Software"), to deal in the Software without
;;; restriction, including without limitation the rights to use, copy,
;;; modify, merge, publish, distribute, sublicense, and/or sell copies
;;; of the Software, and to permit persons to whom the Software is
;;; furnished to do so.  Attribution is appreciated but not required.


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; Settings
;;;

;;; Some subset of these symbols will be defined by fbbuild depending
;;; on the ebook; see fb_book_write_app() in pack.c for more
;;; information.  Below are typical values.

;TI83P .equ 1
;TI73 .equ 1
;BASE_CHARSET .equ 83h		; see fb.h for values

;MULTI_PAGE .equ 1		; use 24-bit addressing
;MULTI_PAGE_BLOCKS .equ 1	; a block may span multiple Flash pages

;BLOCK_SIZE .equ 765
;DYNAMIC_TEXT_BUFFERS .equ 1

;FONT_HEIGHT .equ 7		; Height of font cells
;HIGHLIGHT_HEIGHT .equ 7        ; Number of pixel rows to highlight
;CUSTOM_FONT .equ 1		; Define to enable custom font characters
;TEXT_RTL .equ 1		; Text display right-to-left
;LARGE_FONT .equ 1		; Use large font
;USE_TOC .equ 1			; Include Table of Contents
;USE_BOOKMARKS .equ 1		; Include bookmark support
;COMPRESSED_TITLES .equ 1	; Compress section titles
;NO_BOOK_TITLE .equ 1		; No book title

;OFFSET_BITS .equ 8
;LENGTH_BITS .equ 3
;LENGTH_BIAS .equ 5

;NEWLINE .equ 0D6h
;SPACE .equ 20h

;LINEDELTA .equ 6
;NUMLINES .equ 10


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; Definitions for TI-83 Plus
;;;

 .ifdef TI83P

KEYID .equ 4

;;; System routines

B_CALL .macro lbl
	rst 28h
	;; UNREACHABLE
	.dw _##lbl
  .endm

B_JUMP .macro lbl
	call 50h
	;; UNREACHABLE
	.dw _##lbl
  .endm

_APDBufCpy          .equ 45F7h ; Undocumented; copies saveSScreen to LCD
_AppInit            .equ 404bh
_Arc_Unarc          .equ 4fd8h
_BufClr             .equ 5074h
_ChkFindSym         .equ 42f1h
_ClrLCDFull         .equ 4540h
_CreateAppVar       .equ 4e6ah
_DelVarNoArc        .equ 4fc9h
_GetKey             .equ 4972h
_JForceCmdNoChar    .equ 4027h
_LoadPattern        .equ 4cb1h
_MemClear           .equ 4c30h
_PutAway            .equ 403ch
_PutC               .equ 4504h
_PutS               .equ 450ah
_ReloadAppEntryVecs .equ 4c36h
_RunIndicOff        .equ 4570h
_RunIndicOn         .equ 456dh
_StrCopy            .equ 44e3h

;;; RAM

appData         .equ 8000h
ramCode         .equ 8100h
ramCodeEnd      .equ 822fh
tempSwapArea    .equ 82a5h
curRow          .equ 844bh
lFont_record    .equ 845ah
sFont_record    .equ 8462h
OP1             .equ 8478h
iMathPtr1       .equ 84d3h
iMathPtr2       .equ 84d5h
iMathPtr3       .equ 84d7h
iMathPtr4       .equ 84d9h
asm_data_ptr1   .equ 84ebh
textShadow      .equ 8508h
penCol          .equ 86d7h
penRow          .equ 86d8h
saveSScreen     .equ 86ech
flags           .equ 89f0h
plotSScreen     .equ 9340h
FPS             .equ 9824h
OPS             .equ 9828h
appBackUpScreen .equ 9872h


;;; Flags

graphFlags         .equ 3
graphDraw          .equ 0

textFlags          .equ 5
textInverse        .equ 3

alphaUpDnFlag      .equ 9
appWantAlphaUpDn   .equ 0	; undocumented flag to enable
				; Alpha+Up/Down within FlashApps; this
				; flag is cleared upon exiting.
onFlags            .equ 9
onInterrupt        .equ 4

sGrFlags           .equ 20
grfSChanged        .equ 2

asm_Flag1          .equ 33

fontFlags          .equ 50
fracDrawLFont      .equ 2

scriptFlag         .equ 33h
alt_On             .equ 0	; set to enable ONSCRPT
alt_Off            .equ 1	; set to enable OFFSCRPT

localizeHookFlag   .equ 35h
localizeHookActive .equ 1	; set to enable localize hook

fontHookFlag       .equ 35h
fontHookActive     .equ 5	; set to enable font hook

;;; Keypresses

kRight          .equ 001h
kLeft           .equ 002h
kUp             .equ 003h
kDown           .equ 004h
kEnter          .equ 005h
kAlphaUp        .equ 007h
kAlphaDown      .equ 008h
kClear          .equ 009h
kRecall         .equ 00ch
kBOL            .equ 00eh
kEOL            .equ 00fh
kPrgm           .equ 02dh
kQuit           .equ 040h
kStore          .equ 08ah
k0              .equ 08eh

AppVarObj .equ 15h

 .endif


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; Definitions for TI-73
;;; 

 .ifdef TI73

KEYID .equ 2

;;; System routines

APP_POP_ERRORH .equ 5Ch

B_CALL .macro lbl
	rst 28h
	;; UNREACHABLE
	.dw _##lbl
  .endm

B_JUMP .macro lbl
	call 50h
	;; UNREACHABLE
	.dw _##lbl
  .endm

_APDBufCpy       .equ 455bh
_ChkFindSym      .equ 42d9h
_ClrLCDFull      .equ 44a7h
_CreateAppVar    .equ 4312h
_DelVarNoArc     .equ 432ah
_DisableAPI      .equ 4bdfh
_GetKey          .equ 486dh
_JForceCmdNoChar .equ 401eh
_LoadPattern     .equ 4c51h
_MemClear        .equ 4a47h
_PutC            .equ 446bh
_PutS            .equ 4471h
_RunIndicOn      .equ 44d4h
_RunIndicOff     .equ 44d7h
_StrCopy         .equ 444ah

;;; RAM

appData         .equ 8000h
ramCode         .equ 8100h
tempSwapArea    .equ 8295h
curRow          .equ 83e2h
OP1             .equ 842bh
iMathPtr1       .equ 8486h
iMathPtr2       .equ 8488h
iMathPtr3       .equ 848ah
iMathPtr4       .equ 848ch
asm_data_ptr1   .equ 85afh
lFont_record    .equ 84a3h
sFont_record    .equ 84abh
appRawKeyHandle .equ 85b8h
appPage         .equ 85cbh
appBackUpScreen .equ 8613h
textShadow      .equ 8913h
penCol          .equ 89dfh
penRow          .equ 89e0h
saveSScreen     .equ 8a52h ; correct value - ti73.inc has it wrong
plotSScreen     .equ 9737h
FPS             .equ 9bb2h
OPS             .equ 9bb6h

;;; Flags

graphFlags      .equ 3
graphDraw       .equ 0

textFlags       .equ 5
textInverse     .equ 3

onFlags         .equ 9
onInterrupt     .equ 4

asm_Flag1       .equ 33

fontFlags       .equ 37
fracDrawLFont   .equ 2

;;; Keypresses

kRight      .equ 001h
kLeft       .equ 002h
kDown       .equ 004h
kEnter      .equ 005h
kUp         .equ 003h
kClear      .equ 009h
kRecall     .equ 00ch
kBOL        .equ 00eh
kEOL        .equ 00fh
kPrgm       .equ 02dh
kQuit       .equ 040h
kStore      .equ 08ah
k0          .equ 08eh

AppVarObj .equ 1ah

 .endif


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; Useful macros
;;;

jump .macro addr
     .if ((addr - $) <= 129) && ((addr - $) >= -126)
	jr addr
     .else
	jp addr
     .endif
  .endm

jumpc .macro cond,addr
    .if ((addr - $) <= 129) && ((addr - $) >= -126)
	jr cond,addr
    .else
	jp cond,addr
    .endif
  .endm

mult .macro n
    .if ((n) & ((n) - 1))
	ld b,h
	ld c,l
    .endif
	_mult n
  .endm

_mult .macro n
    .if ((n) > 1)
	_mult ((n) >> 1)
	add hl,hl
      .if ((n) & 1)
	add hl,bc
      .endif
    .endif
  .endm

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; RAM Data
;;; 


;;; We use appData as a fast lookup table for character widths.  This
;;; is needed so we can quickly identify line breaks as we scroll
;;; through the text.

charWidthTable .equ appData

;;; Various other data are stored in tempSwapArea
 .org tempSwapArea

saveScriptFlag:		.ds 1	; Original script flags.  These will
				; be restored upon exiting the app.

saveHookFlag:		.ds 1	; Original font/localize hook flags

firstBlockNumber:	.ds 2	; Index of the first block we have
				; decompressed (the second block is
				; (firstBlockNumber)+1.)

prevLineDestPtr:	.ds 2	; Temporary pointer used when
				; scrolling backwards

tocTop:			.ds 2	; Pointer to section table entry at
				; top of Table of Contents view

tocCurrent:		.ds 2	; Pointer to section table entry
				; currently selected

tocSelectedRow:		.ds 1	; Y coordinate of the currently
				; selected row

huffmanTree:		.ds 288	; Complete Huffman tree (copied into
				; RAM so it is accessible to the
				; decompression code) -- 288 bytes is
				; the maximum possible size of the
				; tree, which occurs if all 256 byte
				; values are used.

;;; Check for overflow
 .if $ > tempSwapArea + 322
 .error "tempSwapArea overflow"
 .endif

;;; Pointers (use OS managed pointers so that we don't need to worry
;;; about correcting them when we create the bookmark file)

firstBlockPtr     .equ iMathPtr1 ; Pointer to buffer holding first block

firstBlockEndPtr  .equ iMathPtr2 ; Pointer to end of first block

secondBlockPtr    .equ iMathPtr3 ; Pointer to buffer holding second block

secondBlockEndPtr .equ iMathPtr4 ; Pointer to end of second block

viewStartPtr      .equ asm_data_ptr1 ; Starting address of view --
				     ; this may be located in either
				     ; of the two buffers


;;; Buffers for text if not using dynamic allocation
TextBuffer1 .equ plotSScreen
TextBuffer2 .equ appBackUpScreen

;;; Screen buffer
ScreenBuffer .equ saveSScreen

;;; Used for RAM code
DecompCodeMem .equ ramCode

;;; Used for decompressing section titles (or other small strings)
TitleBuffer .equ textShadow

;;; asm_Flag1
atEndOfFile .equ 0



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; Reader Options
;;;

SCREENBOTTOM .equ 65 - FONT_HEIGHT

 .ifdef TEXT_RTL
STARTING_COLUMN .equ 96
 .else
STARTING_COLUMN .equ 0
 .endif


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; Flash App Header
;;;

	.org 4000h

	.db 80h,0Fh, 0, 0, 0, 0 	; Application (length set when signing)

	 .db 80h,12h			; App signing key ID
	  .db 01h,KEYID

	 .db 80h,21h			; Major version number
	  .db 1

	 .db 80h,31h			; Minor version number
	  .db 1

	 .db 80h,40h + AppNameL		; App name
AppName:  .incbin "fb:appname"
AppNameL .equ $ - AppName

	 .db 80h,81h			; Number of pages (set when signing)
	  .db 1

	 .db 80h,90h			; No default splash screen

	 .db 80h,0A1h			; Maximum hardware compatibility
	  .db 1

	 .db 03h,26h			; Date stamp block
	  .db 09h,04h
	   .db 04h,6Fh,1Bh,80h

	 .db 02h,0Dh, 40h		; Fake date stamp signature
	  .db 0A1h, 06Bh, 099h, 0F6h, 059h, 0BCh, 067h, 0F5h
	  .db 085h, 09Ch, 009h, 06Ch, 00Fh, 0B4h, 003h, 09Bh
	  .db 0C9h, 003h, 032h, 02Ch, 0E0h, 003h, 020h, 0E3h
	  .db 02Ch, 0F4h, 02Dh, 073h, 0B4h, 027h, 0C4h, 0A0h
	  .db 072h, 054h, 0B9h, 0EAh, 07Ch, 03Bh, 0AAh, 016h
	  .db 0F6h, 077h, 083h, 07Ah, 0EEh, 01Ah, 0D4h, 042h
	  .db 04Ch, 06Bh, 08Bh, 013h, 01Fh, 0BBh, 093h, 08Bh
	  .db 0FCh, 019h, 01Ch, 03Ch, 0ECh, 04Dh, 0E5h, 075h

	 .db 80h,7Fh, 0,0,0,0		; Program image (length ignored)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; Initialization
;;;

 .ifdef TI73

	;; Nonsensical startup code (required for all apps)

	call APP_POP_ERRORH
	B_CALL DisableAPI
	ld hl,RawKeyHandle
	ld (appRawKeyHandle),hl
	in a,(6)
	ld (appPage),a
 .endif

 .ifdef DYNAMIC_TEXT_BUFFERS

;;; FPS must be allocated in multiples of 9 bytes
MEM_REQUIRED .equ BLOCK_SIZE * 2 + 5
DYNAMIC_ALLOCATION .equ MEM_REQUIRED + 8 - ((MEM_REQUIRED + 8) % 9)

	;; Dynamically allocate memory (at the top of the FPS) for
	;; text buffers.  (This is used only when block size is
	;; greater than 765.)

	ld hl,(FPS)
	ld de,DYNAMIC_ALLOCATION
	add hl,de
	jr c,MemoryError
	ld bc,(OPS)
	sbc hl,bc
	jr nc,MemoryError
	add hl,bc
  .ifdef USE_BOOKMARKS
	ld (FPS),hl		; If bookmarks are enabled (i.e., we
				; may need to create the bookmark file
				; at some point), we need to reserve
				; this area on the FPS so the OS knows
				; it is in use.
  .endif
	;; Leave room for newline + nul at end of block, and nul at
	;; start of block
	;; note: nul at start of 2nd block also marks end of 1st block
	ld de,-(BLOCK_SIZE + 3)
	add hl,de
	ld (hl),0
	inc hl
	ld (secondBlockPtr),hl

	add hl,de
	ld (hl),0
	inc hl
	ld (firstBlockPtr),hl

 .else ; ! DYNAMIC_TEXT_BUFFERS

	;; Use up statically allocated buffers.

	ld hl,TextBuffer1
	ld (hl),0
	inc hl
	ld (firstBlockPtr),hl

	ld hl,TextBuffer2
	ld (hl),0
	inc hl
	ld (secondBlockPtr),hl

	set graphDraw,(iy + graphFlags)	; graph dirty

  .ifdef TI83P
	set grfSChanged,(iy + sGrFlags) ; force redraw if screen split
  .endif

 .endif ; ! DYNAMIC_TEXT_BUFFERS

	ld (iy + asm_Flag1),0

 .ifdef TI83P
	;; We disable scripts while the app is running so that we can
	;; use appData as safe RAM.  We also disable the font and
	;; localize hooks so that the default OS characters (rather
	;; than localized characters) are displayed, in the absence of
	;; custom characters supplied by the ebook itself.

	ld hl,flags + scriptFlag
	ld a,(hl)
	ld (saveScriptFlag),a
	and ~((1<<alt_On) | (1<<alt_Off))
	ld (hl),a
	inc hl
	inc hl
	ld a,(hl)
	ld (saveHookFlag),a
	and ~((1<<localizeHookActive) | (1<<fontHookActive))
	ld (hl),a

	;; Set monitor vectors for putaway control
	ld hl,AppVecs
	B_CALL AppInit

	;; Enable Alpha+Up/Down
	set appWantAlphaUpDn,(iy + alphaUpDnFlag)
 .endif

 .ifdef LARGE_FONT
	set fracDrawLFont,(iy + fontFlags)
 .endif

	;; Load Huffman tree into safe RAM.  It will be used by the
	;; decompression code.
	ld hl,fbCompressionData + 3
	ld de,huffmanTree
	ld bc,288
	ldir

	;; Initialize the decompressor and load the first two blocks
	;; of text.
	ld hl,8000h
	ld (firstBlockNumber),hl
	ld hl,(fbSectionTable)
	call GotoSection

	;; Generate the character width table.
	ld hl,charWidthTable + 1
CharWidthTableLoop:
	push hl
	 ld a,l
	 call LoadPattern
	 ld a,(hl)
	 pop hl
	ld (hl),a
	inc l
	jr nz,CharWidthTableLoop

	xor a
	ld (charWidthTable),a
	dec a
	ld (charWidthTable + NEWLINE),a
	jr MainRedisplay

 .ifdef DYNAMIC_TEXT_BUFFERS
MemoryError:
	B_CALL ClrLCDFull
	ld hl,0
	ld (curRow),hl
	ld hl,MemoryErrorStr
	ld de,OP1
	push de
	 B_CALL StrCopy
	 pop hl
	B_CALL PutS
	B_CALL GetKey
	B_CALL JForceCmdNoChar
	;; UNREACHABLE
 .endif


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; Main Program
;;;

PageDown:
	bit atEndOfFile,(iy + asm_Flag1)
	jr nz,MainKeyLoop
	ld hl,(viewStartPtr)
	ld b,NUMLINES - 1
PageDown_Loop:
	push bc
	 call GetNextLine
	 pop bc
	djnz PageDown_Loop
	jr MainSetViewAddress

PageUp:
	ld hl,(viewStartPtr)
	ld b,NUMLINES - 1
PageUp_Loop:
	push bc
	 call GetPrevLine
	 pop bc
	djnz PageUp_Loop
	jr MainSetViewAddress

Up:
	ld hl,(viewStartPtr)
	call GetPrevLine
	jr MainSetViewAddress

Down:
	bit atEndOfFile,(iy + asm_Flag1)
	jr nz,MainKeyLoop
	ld hl,(viewStartPtr)
	call GetNextLine
MainSetViewAddress:
	ld (viewStartPtr),hl
MainRedisplay:
	ld hl,STARTING_COLUMN
	ld (penCol),hl

	ld hl,ScreenBuffer
 .ifdef TI73
	ld bc,768
	B_CALL MemClear
 .else
	B_CALL BufClr
 .endif

	set atEndOfFile,(iy + asm_Flag1)
	ld hl,(viewStartPtr)
MainRedisplay_Loop:
	call RedisplayLine
	jr c,MainRedisplay_EOF
 .ifdef TEXT_RTL
	ld a,STARTING_COLUMN
 .else
	xor a
 .endif
	ld (penCol),a
	ld a,(penRow)
	add a,LINEDELTA
	ld (penRow),a
	cp SCREENBOTTOM
	jr c,MainRedisplay_Loop
	res atEndOfFile,(iy + asm_Flag1)
MainRedisplay_EOF:
	B_CALL RunIndicOff
	B_CALL APDBufCpy
MainKeyLoop:
	res onInterrupt,(iy + onFlags)
	B_CALL GetKey
	dec a			; kRight
PageDown_:
	jr z,PageDown
	dec a			; kLeft
	jr z,PageUp
	dec a			; kUp
	jr z,Up
	dec a			; kDown
	jr z,Down
	dec a			; kEnter
	jr z,PageDown_
 .ifdef TI83P
	sub kAlphaUp - kEnter
	jr z,PageUp
	dec a			; kAlphaDown
	jr z,PageDown_
	dec a			; kClear
 .else
	sub kClear - kDown
 .endif
	jr z,Quit
	sub kBOL - kClear
	jr z,PreviousSection
	dec a			; kEOL
	jr z,NextSection

 .ifdef USE_TOC
	cp kPrgm - kEOL
	jumpc z,TableOfContents
 .endif
 .ifdef USE_BOOKMARKS
	cp kStore - kEOL
	jr z,StoBookmark
	cp kRecall - kEOL
	jr z,RclBookmark
 .endif
	cp kQuit - kEOL
	jr nz,MainKeyLoop
Quit:	B_CALL JForceCmdNoChar
	;; UNREACHABLE

PreviousSection:
	call GetPosition
	ld a,h
	or l
	dec hl
	jr nz,PreviousSection_OK
	ld a,b
	or c
	jr z,MainKeyLoop
	dec bc
PreviousSection_OK:
	call GetSectionAtPosition
	jr MainGotoSection

NextSection:
	call GetCurrentSection
	call GetNextSection
	jr c,MainKeyLoop
MainGotoSection:
	call GotoSection
MainRedisplay_:
	jump MainRedisplay

 .ifdef USE_BOOKMARKS
StoBookmark:
	call PromptBookmarkNum
	jr c,MainRedisplay_
	call GetPosition
	ex de,hl
	ld (hl),e
	inc hl
	ld (hl),d
	inc hl
	ld (hl),c
	inc hl
	ld (hl),b
	jr MainRedisplay_

RclBookmark:
	call PromptBookmarkNum
	jr c,MainRedisplay_
	ex de,hl
	jr MainGotoSection
 .endif


 .ifdef DYNAMIC_TEXT_BUFFERS
MemoryErrorStr:
	.db "ERROR: More free"
	.db "RAM is needed to"
	.db "read this ebook."
	.db "  Press a key",0
 .endif


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; Reader Support Routines
;;;

 .ifdef TI83P

;;; We set a putaway vector to restore the hooks and flags that we
;;; destroyed at startup.

;;; Note there is no need to reset the appWantAlphaUpDn flag (the OS
;;; resets it for us.)  I also believe there's no need to reset
;;; fracDrawLFont on the 73.

AppVecs:
	.dw AppMain, AppPPutAway, AppPutAway, AppRedisp, AppErrorEP, AppSizeWind
	.db 0

AppPutAway:
  .ifdef LARGE_FONT
	res fracDrawLFont,(iy + fontFlags)
  .endif
	ld hl,(saveScriptFlag)
	ld a,l
	ld (flags + scriptFlag),a
	ld a,h
	ld (flags + localizeHookFlag),a
	B_CALL ReloadAppEntryVecs
	B_JUMP PutAway
 .endif


AppMain:
AppPPutAway:
AppRedisp:
AppErrorEP:
AppSizeWind:
RawKeyHandle:
	ret

;;; Display line starting at HL, advance HL to start of next line
;;; Return with C set if at EOF
RedisplayLine:
	call GetLineLength
	ret c
	ld b,a
	call VPutSN
	jr GetNextLine_Finish

;;; Same as above, without actually displaying anything.
;;; Note that we also replace the space at the end of the line with a
;;; newline character, if possible; this makes scrolling upwards
;;; through a long paragraph much faster.
GetNextLine:
	call GetLineLength
	ret c
	ld c,a
	ld b,0
	add hl,bc
GetNextLine_Finish:
	dec hl
	ld a,(hl)
 .ifdef ZERO_WIDTH_SPACE
	cp ZERO_WIDTH_SPACE
	jr z,GetNextLine_SetFinalNL
 .endif
	xor SPACE		; clear carry flag
	jr nz,GetNextLine_IgnoreFinal
GetNextLine_SetFinalNL:
	ld (hl),NEWLINE
GetNextLine_IgnoreFinal:
	inc hl
	ret


;;; GetPrevLine -- move to previous line
GetPrevLine_StartOfSecondBlock:
	ld hl,(firstBlockEndPtr)
GetPrevLine:
	ld (prevLineDestPtr),hl
	dec hl
	ld a,(hl)
	or a
	jr z,GetPrevLine_StartOfBlock
GetPrevLine_SearchLoop:
	dec hl
	ld a,(hl)
	cp NEWLINE
	jr z,GetPrevLine_FoundNL
	or a
	jr nz,GetPrevLine_SearchLoop
GetPrevLine_FoundNL:
	;; HL points to a newline or zero
	inc hl
	push af
GetPrevLine_Loop:
	 pop af
	push hl
	 call GetNextLine
	 ld de,(prevLineDestPtr)
	 or a
	 sbc hl,de
	 add hl,de
	 jr c,GetPrevLine_Loop
	 pop hl
	ret
GetPrevLine_StartOfBlock:
	;; need to move to previous block
	inc hl
	ld de,(secondBlockPtr)
	sbc hl,de
	jr z,GetPrevLine_StartOfSecondBlock
	call DecompressPrevious
	jr nc,GetPrevLine_StartOfSecondBlock
	ld hl,(firstBlockPtr)
	ret


;;; Determine length of line to display
;;; HL -> start of line
;;; Return A = number of characters to display (incl. newline)
;;; HL adjusted to point to next block if necessary
;;; Destroys AF, BC, DE
;;; Carry if at EOF
GetLineLength:
	ld a,(hl)
	or a
	jr nz,GetLineLength_SameBlock
	ld de,(firstBlockEndPtr)
	sbc hl,de
	jr z,GetLineLength_SecondBlock

	call DecompressNext
	ld a,0
	ld hl,(secondBlockEndPtr)
	ret c

GetLineLength_SecondBlock:
	ld hl,(secondBlockPtr)
GetLineLength_SameBlock:
	ld c,1			; C = current X coordinate (biased
				; so that adding FF will always carry)
	ld d,charWidthTable / 256
	push hl
GetLineLength_SetWord:
	 ld b,l			; B = last known post-word-boundary
				; position
GetLineLength_Loop:
	 ld e,(hl)
	 inc hl
	 ld a,(de)
	 add a,c
	 jr c,GetLineLength_EOL
	 cp 97 + 1
	 jr nc,GetLineLength_Done
	 ld c,a
	 ld a,e
 .ifdef ZERO_WIDTH_SPACE
	 cp ZERO_WIDTH_SPACE
	 jr z,GetLineLength_SetWord
 .endif
 .ifdef HYPHEN
	 cp HYPHEN
	 jr z,GetLineLength_SetWord
 .endif
 .ifdef SOFT_HYPHEN
	 cp SOFT_HYPHEN
	 jr z,GetLineLength_SetWord
 .endif
	 cp SPACE
	 jr nz,GetLineLength_Loop
	 jr GetLineLength_SetWord
GetLineLength_Done:
	 ld a,e
	 cp SPACE
	 jr nz,GetLineLength_NotSpace
	 ld b,l
GetLineLength_NotSpace:
	 ld a,b
	 ld c,l
	 pop hl
	sub l
	or a
	ret nz
	ld a,c
	dec a
	sub l
	cp a
	ret
GetLineLength_EOL:
	 ld a,l
	 pop hl
	sub l
	cp a
	ret


;;; Get "absolute address" in BCHL
;;; (BC = block number, HL = offset into block)
GetPosition:
	;; check if view is within first or second buffer
	ld hl,(viewStartPtr)
	ld bc,(firstBlockEndPtr)
	or a
	sbc hl,bc
	jr nc,GetPosition_SecondBlock
	add hl,bc
	ld bc,(firstBlockPtr)
	or a
	sbc hl,bc
	jr c,GetPosition_SecondBlock
	ld bc,(firstBlockNumber)
	ret
GetPosition_SecondBlock:
	add hl,bc
	ld bc,(secondBlockPtr)
	or a
	sbc hl,bc
	ld bc,(firstBlockNumber)
	inc bc
	ret


;;; Find the section table entry at or before the current position
;;; Return HL -> section table
GetCurrentSection:
	call GetPosition
GetSectionAtPosition:
	ex de,hl
	ld hl,(fbSectionTable)
	inc hl
	inc hl
	inc hl
GetSectionAtPosition_Loop:
	inc hl
	inc hl
	inc hl
	ld a,e
	sub (hl)
	inc hl
	ld a,d
	sbc a,(hl)
	inc hl
	ld a,c
	sbc a,(hl)
	inc hl
	ld a,b
	sbc a,(hl)
	jr nc,GetSectionAtPosition_Loop
	ld de,-9
	add hl,de
	ret

;;; HL -> section table entry; move to previous section
;;; Carry if we were already at the first section
GetPrevSection:
	ld de,(fbSectionTable)
	or a
	sbc hl,de
	scf
	ret z
	add hl,de
	ld de,-6
	add hl,de
	or a
	ret

;;; HL -> section table entry; move to next section
;;; Carry if we were already at the first section
GetNextSection:
	ld de,8
	add hl,de
	ld a,(hl)
	inc hl
	and (hl)
	dec hl
	dec hl
	dec hl
	inc a
	ret nz
	scf
	ret

;;; Move the view to the start of a section
;;; HL points to a section table entry
GotoSection:
	ld c,(hl)		; get section address in DEBC
	inc hl
	ld b,(hl)
	inc hl
	ld e,(hl)
	inc hl
	ld d,(hl)
	ld hl,(firstBlockNumber)
	or a
	sbc hl,de		; delta = 0 -> no need to decompress,
				; new view pointer is in the first
				; block
	jr z,GotoSection_FirstBlock
	dec hl
	dec hl
	inc h
	jr nz,GotoSection_Jump
	inc l			; delta = 1 -> decompress one preceding block
	jr z,GotoSection_PreviousBlock
	inc l
	inc l			; delta = -1 -> no need to decompress,
				; new view pointer is in the second
				; block
	jr z,GotoSection_SecondBlock
	inc l			; delta = -2 -> decompress one
				; following block
	jr z,GotoSection_NextBlock
GotoSection_Jump:
	ex de,hl
	push bc
	 ld (firstBlockNumber),hl
	 push hl
	  inc hl
	  call GetBlockPointer
	  call DecompressBlock
	  call SwapBuffers
	  pop hl
	 call GetBlockPointer
	 call DecompressBlock
	 pop bc
	jr GotoSection_FirstBlock

GotoSection_PreviousBlock:
	push bc
	 call DecompressPrevious
	 pop bc
GotoSection_FirstBlock:
	ld hl,(firstBlockPtr)
GotoSection_Done:
	add hl,bc
	ld (viewStartPtr),hl
	ret

GotoSection_NextBlock:
	push bc
	 call DecompressNext
	 pop bc
GotoSection_SecondBlock:
	ld hl,(secondBlockPtr)
	jr GotoSection_Done


;;; Decompress one preceding block.  The current "first" block becomes
;;; the new "second" block; the block before it becomes the new
;;; "first" block.  Carry if we were already at block 0.
DecompressPrevious:
	ld hl,(firstBlockNumber)
	ld a,h
	or l
	scf
	ret z
	dec hl
	ld (firstBlockNumber),hl
	call GetBlockPointer
	call SwapBuffers

;;; Decompress a block at (A)DE.  Write decompressed data to
;;; (firstBlockPtr), put a zero at the end and set (firstBlockEndPtr).
DecompressBlock:
	ld hl,(firstBlockPtr)
	call Decompress
	ld (firstBlockEndPtr),hl
	ret

;;; Decompress one following block.  The current "second" block
;;; becomes the new "first" block; the block after it becomes the new
;;; "second" block.  Carry if we were already at the last block.
DecompressNext:
	ld de,(firstBlockNumber)
	inc de
	ld hl,(fbNumBlocks)
	dec hl
	scf
	sbc hl,de
	ret c
	ex de,hl
	ld (firstBlockNumber),hl
	inc hl
	call GetBlockPointer
	call DecompressBlock

;;; Swap decompression buffer pointers.
;;; (Preserves A, DE)
SwapBuffers:
	ld hl,(firstBlockEndPtr)
	ld bc,(secondBlockEndPtr)
	ld (firstBlockEndPtr),bc
	ld (secondBlockEndPtr),hl
	ld hl,(firstBlockPtr)
	ld bc,(secondBlockPtr)
	ld (firstBlockPtr),bc
	ld (secondBlockPtr),hl
	ret

;;; Look up block address.  HL = block number.
;;; Return (A)DE = address of compressed data.
GetBlockPointer:
 .ifdef MULTI_PAGE
	ld d,h
	ld e,l
	add hl,de
	add hl,de
 .else
	add hl,hl
 .endif
	ld de,(fbBlockTable)
	add hl,de
	ld e,(hl)
	inc hl
	ld d,(hl)
	res 7,d
	set 6,d			; High bits of block table addresses
				; are used as flags
 .ifdef MULTI_PAGE
	inc hl
	in a,(6)
  .ifdef TI73
	add a,(hl)
  .else
	sub (hl)
  .endif
 .endif
	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; Bookmarks
;;;

 .ifdef USE_BOOKMARKS

;;; Ask user to press a key 0-9.  Return with carry if (s)he does not
;;; do so.  Otherwise, return a pointer to the corresponding 4-byte slot
;;; in the bookmark file.
PromptBookmarkNum:
	ld hl,7
	ld (curRow),hl
	set textInverse,(iy + textFlags)
	ld hl,BookmarkPrompt
	ld b,16
PromptBookmarkNumLoop:
	ld a,(hl)
	inc hl
	B_CALL PutC
	djnz PromptBookmarkNumLoop
	res textInverse,(iy + textFlags)
	B_CALL GetKey
	sub k0
	ret c
	cp 10
	ccf
	ret c
	add a,a
	add a,a
	ld l,a
	ld h,0
	push hl

PromptBookmarkNum_FindFileLoop:
	 ld hl,BookmarkFileName
	 rst 20h
	 B_CALL ChkFindSym
	 jr c,PromptBookmarkNum_Create
PromptBookmarkNum_Found:
 .ifndef TI73
	 ld a,b
	 or a
	 jr nz,PromptBookmarkNum_Archived
 .endif
	 push hl
	  push de
	   inc de
	   inc de
	   ld hl,BookmarkFileSignature
	   ld b,4
PromptBookmarkNum_CheckLoop:
	   ld a,(de)
	   cp (hl)
	   inc de
	   inc hl
	   jr nz,PromptBookmarkNum_Invalid
	   djnz PromptBookmarkNum_CheckLoop
	   pop af
	  pop af
	 jr PromptBookmarkNum_Done

PromptBookmarkNum_Invalid:
	   pop de
	  pop hl
	 B_CALL DelVarNoArc
	 jr PromptBookmarkNum_FindFileLoop

 .ifndef TI73
PromptBookmarkNum_Archived:
	 B_CALL Arc_Unarc
	 jr PromptBookmarkNum_FindFileLoop
 .endif

PromptBookmarkNum_Create:
	 ld hl,44
	 B_CALL CreateAppVar
	 inc de
	 inc de
	 ld hl,BookmarkFileSignature
	 ld bc,4
	 ldir
	 push de
	  ex de,hl
	  ld bc,40
	  B_CALL MemClear
	  pop de
PromptBookmarkNum_Done:
	 pop hl
	add hl,de
	ex de,hl
	ret

BookmarkPrompt:
	.db " Bookmark #0-9? "

;;; The bookmark file name is generated by fbbuild; it consists of the
;;; first 4 characters of the app name, followed by a 4-character hash
;;; (to prevent accidental collisions between incompatible versions of
;;; the same app.)
BookmarkFileName:
	.db AppVarObj
	.incbin "fb:markname"

BookmarkFileSignature:
	.db "FBMk"

 .endif


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; Table of Contents
;;;

 .ifdef USE_TOC

TableOfContents:
	call GetCurrentSection
	call GetThisOrPrevNamedSection
	jr nc,TableOfContents_SetupOK
	ld hl,(fbSectionTable)
	call GetThisOrNextNamedSection
TableOfContents_SetupOK:
	ld (tocCurrent),hl
; 	ld de,-18
; 	add hl,de
; 	ld (tocTop),hl
; 	ld de,(fbSectionTable)
; 	sbc hl,de
; 	jr nc,TableOfContents_Redraw
; 	ex de,hl
; 	call GetThisOrNextNamedSection
	ld (tocTop),hl
TableOfContents_Redraw:
	ld hl,ScreenBuffer
 .ifdef TI73
	ld bc,768
	B_CALL MemClear
 .else
	B_CALL BufClr
 .endif
	ld hl,STARTING_COLUMN
	ld (penCol),hl

 .ifndef NO_BOOK_TITLE
	ld hl,(fbTitle)
	call VPutS
	ld a,(penRow)
	add a,3
	ld (penRow),a
	sub 2
	call GetRow
	ld (hl),0AAh
	ld d,h
	ld e,l
	inc de
	ld bc,11
	ldir
 .endif

	ld de,(tocTop)
TableOfContents_RedrawLoop:
	ld hl,(tocCurrent)
	or a
	sbc hl,de
	jr nz,TableOfContents_NotSelected
	ld a,(penRow)
	ld (tocSelectedRow),a
TableOfContents_NotSelected:
	ld hl,4
	add hl,de
	push de
	 ld a,1
	 ld (penCol),a
	 ld e,(hl)
	 inc hl
	 ld d,(hl)
	 ld a,d
	 or e
	 call nz,PutTitle
	 pop hl
	call GetNextSection
	jr c,TableOfContents_Rehighlight
	ld a,(penRow)
	cp 65 - HIGHLIGHT_HEIGHT
	ex de,hl
	jr c,TableOfContents_RedrawLoop
TableOfContents_Rehighlight:
	ld a,(tocSelectedRow)
	call GetRow
	ld b,HIGHLIGHT_HEIGHT * 12
	call Invert
	B_CALL RunIndicOff
	B_CALL APDBufCpy
TableOfContents_KeyLoop:
	res onInterrupt,(iy + onFlags)
	B_CALL GetKey
	sub kUp
	jr z,TableOfContents_Up
	dec a			; kDown
	jr z,TableOfContents_Down
	cp kQuit - kDown
	jumpc z,Quit
	cp kClear - kDown
	jumpc z,MainRedisplay
	dec a			; kEnter
	jr nz,TableOfContents_KeyLoop
	ld hl,(tocCurrent)
	jump MainGotoSection

TableOfContents_Up:
	ld hl,(tocCurrent)
	call GetPrevNamedSection
	jr c,TableOfContents_KeyLoop
	ld (tocCurrent),hl
	ld de,(tocTop)
	sbc hl,de
	jr nc,TableOfContents_UpQuick
	add hl,de
TableOfContents_MoveSlow:
	ld (tocTop),hl
	jump TableOfContents_Redraw

TableOfContents_UpQuick:
	ld a,(tocSelectedRow)
	ld b,a
	sub LINEDELTA
TableOfContents_MoveQuick:
	ld (tocSelectedRow),a
	ld a,b
	call GetRow
	ld b,HIGHLIGHT_HEIGHT * 12
	call Invert
	jr TableOfContents_Rehighlight

TableOfContents_Down:
	ld hl,(tocCurrent)
	call GetNextNamedSection
	jr c,TableOfContents_KeyLoop
	ld (tocCurrent),hl
	ld a,(tocSelectedRow)
	ld b,a
	add a,LINEDELTA
	cp SCREENBOTTOM
	jr c,TableOfContents_MoveQuick
	ld hl,(tocTop)
	call GetNextNamedSection
	jr TableOfContents_MoveSlow


Invert:
	ld a,(hl)
	cpl
	ld (hl),a
	inc hl
	djnz Invert
	ret

GetRow:
	ld l,a
	add a,a
	add a,l
	ld l,a
	ld h,0
	add hl,hl
	add hl,hl
	ld de,ScreenBuffer
	add hl,de
	ret

GetNextNamedSection:
	call GetNextSection
	ret c
GetThisOrNextNamedSection:
	call CheckSectionName
	jr z,GetNextNamedSection
	ret

GetPrevNamedSection:
	call GetPrevSection
	ret c
GetThisOrPrevNamedSection:
	call CheckSectionName
	jr z,GetPrevNamedSection
	ret

CheckSectionName:
	ld de,4
	add hl,de
	ld a,(hl)
	inc hl
	or (hl)
	inc e
	sbc hl,de
	or a
	ret

PutTitle:
 .ifdef COMPRESSED_TITLES
 	in a,(6)
 	ld hl,TitleBuffer
 	push hl
 	 call Decompress
 	 pop hl
 .else
	ex de,hl
 .endif
VPutS:	ld a,(hl)
	inc hl
	cp NEWLINE
	jr z,VPutSNewline
	or a
	ret z
	call VPutMap
	jr VPutS
VPutSNewline:
 .ifdef TEXT_RTL
	ld a,STARTING_COLUMN
 .else
	xor a
 .endif
	ld (penCol),a
	ld a,(penRow)
	add a,LINEDELTA
	ld (penRow),a
	jr VPutS

 .endif


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; Text Display
;;;

;;; Display B characters starting at HL.
VPutSN:
	ld a,b
	or a
	ret z
	push de
VPutSN_Loop:
	 ld a,(hl)
	 inc hl
	 call VPutMap
VPutSN_Next:
	 djnz VPutSN_Loop
	 pop de
	ret


;;; Display a character to the screen buffer.
VPutMap:
	cp NEWLINE
	ret z
	push hl
	 push bc
	  call LoadPattern	; returns IX -> bitmap and C = height
	  ld a,(penRow)
	  ld l,a
	  ld h,0
	  ld e,l
	  ld d,h
	  add hl,hl
	  add hl,de
	  add hl,hl
	  add hl,hl		; HL = row * 12
 .ifdef TEXT_RTL
	  ld a,(penCol)
	  ld e,a
	  sub (ix)
	  ld (penCol),a
	  ld a,e
 .else
	  ld a,(penCol)
	  add a,(ix)
	  ld (penCol),a
 .endif
	  push af
	   rrca
	   rrca
	   rrca
	   and 1Fh
	   ld e,a
	   add hl,de
	   ld de,ScreenBuffer
	   add hl,de
	   pop af
	  and 7
	  xor 7
	  inc a			; shift count = 8 - (xpos % 8)
	  ld b,a
	  ld d,0
VPutMap_Loop:
	  ex de,hl
	  ld l,(ix + 1)
	  ld a,b
VPutMap_ShiftLoop:
	  add hl,hl
	  djnz VPutMap_ShiftLoop
	  ld b,a
	  ld a,(de)
	  or l
	  ld (de),a
	  dec de
	  ld a,(de)
	  or h
	  ld (de),a
	  ex de,hl
	  ld de,13
	  add hl,de
	  inc ix
	  dec c
	  jr nz,VPutMap_Loop
	  pop bc
	 pop hl
	ret


;;; Load character bitmap.
;;; Return C = height, (IX) = width, (IX+1) to (IX+C) = bitmap
LoadPattern:
 .ifdef CUSTOM_FONT
	ld hl,(fbFontTable)
LoadPattern_SearchLoop:
	ld b,a
	sub (hl)
	inc hl
	ld d,0
	jr c,LoadPattern_Next
	cp b
	jr z,LoadPattern_Default ; (HL) was zero -> end of table
	cp (hl)
	jr nc,LoadPattern_Next
	inc hl
	ld e,a
	ex de,hl
	mult FONT_HEIGHT + 1
	add hl,de
	push hl
	 pop ix
	ld c,FONT_HEIGHT
	ret

LoadPattern_Next:
	ld a,b
	ld e,(hl)
	inc hl
	ex de,hl
	mult FONT_HEIGHT + 1
	add hl,de
	jr LoadPattern_SearchLoop

LoadPattern_Default:
;	ld a,b
 .endif
	B_CALL LoadPattern
 .ifdef LARGE_FONT
	ld ix,lFont_record
 .else
	ld ix,sFont_record
 .endif
	ld c,7
	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; Decompression
;;;

;;; Decompress data at (A)DE to HL.  Return HL -> end of data.
Decompress:
	push de
	 push hl
	  B_CALL RunIndicOn
	  ld hl,DecompCode
	  ld de,DecompCodeMem
	  ld bc,DecompCodeSize
	  ldir
 .ifdef MULTI_PAGE
	  ld b,a
	  in a,(6)
	  ld (Decompress_ReturnPage),a
	  ld a,b
 .endif
	  pop hl
	 pop de
	jp DecompCodeMem


;;; RAM code for decompression
DecompCode:
	.rorg DecompCodeMem

 .ifdef MULTI_PAGE
	out (6),a
 .endif

	push de
	 pop ix
	ld (decompress_OutPtr),hl
	ld d,80h
Decompress_Loop:
	;; Main decompression loop

	;; D = bit reservoir
	;; E = LSB data address

	;; Huffman tree compression scheme:
	;; The tree is stored at HuffmanTree (this is in RAM.)
	;; Bit ordering MS-LS.
	;; For a "node" in the tree, write a 1 bit, then the "0"
	;; branch, then the "1" branch.
	;; For a "leaf", write a 0 bit, then the 8 data bits.
	;;
	;; For example:
	;;
	;;    *
	;;   / \
	;;  A   *
	;;     / \
	;;    B   C
	;;
	;; This tree would be encoded as
	;;  1 0 01000001 1 0 01000010 0 01000011
	;;
	;; or, in byte-packed form,
	;;  10010000 01100100 00100010 00011xxx
	;;
	;; and it means that 'A' is represented by '0', B by '10', and
	;; C by '11' in the compressed data.

	ld hl,huffmanTree
	ld b,80h
Decompress_BitLoop:
	call GetBit
	jr nc,Decompress_Bit0
	;; Got 1 bit -- skip over this subtree
	ld c,1
	jr Decompress_Bit1Loop
Decompress_Bit1SkipByte:
	dec c
	jr z,Decompress_Bit1Done
	inc hl
	rrc b
	jr nc,Decompress_Bit1Loop
	inc hl
Decompress_Bit1Loop:
	ld a,(hl)
	and b
	jr z,Decompress_Bit1SkipByte
	inc c
	rrc b
	jr nc,Decompress_Bit1Loop
	inc hl
	jr Decompress_Bit1Loop
Decompress_Bit1Done:
	inc hl
	rrc b
	jr nc,Decompress_BitFinal
	inc hl

Decompress_Bit0:
Decompress_BitFinal:
	;; Got 0 bit -- use this subtree
	ld a,(hl)
	and b
	jr z,Decompress_GotHuffmanValue
	rrc b
	jr nc,Decompress_BitLoop
	inc hl
	jr Decompress_BitLoop

Decompress_GotHuffmanValue:
	ld a,(hl)
	inc hl
	ld l,(hl)
	ld h,a
Decompress_ShiftHuffmanValueLoop:
	add hl,hl
	rlc b
	jr nc,Decompress_ShiftHuffmanValueLoop
	;; Check if output byte is zero (LZ backreference)
	ld a,h
	or a
	jr z,Decompress_LZ
Decompress_EndOfBlock:
decompress_OutPtr equ $ + 1
	ld hl,0
	ld (hl),a
	inc hl
	ld (decompress_OutPtr),hl
	jr nz,Decompress_Loop
	ld (hl),0
 .ifdef MULTI_PAGE
Decompress_ReturnPage .equ $ + 1
	ld a,0
	out (6),a
 .endif
	;; Note: this routine should always return with carry flag
	;; reset
	ret

Decompress_LZ:

	;; A zero-valued leaf in the Huffman tree is an LZ
	;; backreference.  This is followed by some number of offset
	;; bits, then some number of length bits.  If the offset is
	;; zero, that means EOF (and don't bother reading the length.)
	;; OFFSET_BITS, LENGTH_BITS, and LENGTH_BIAS are determined by
	;; fbbuild.

	ld l,h			; H was already set to zero above

	ld b,OFFSET_BITS	; Number of offset bits can range from
				; 1 to 16 (but less than 8 would be
				; unusual.)  The best value seems to
				; be about the log of the block size
				; minus 1 (i.e., maximum LZ range is
				; half the block size.)
Decompress_LZOffsetLoop:
	call GetBit
	adc hl,hl
	djnz Decompress_LZOffsetLoop
	ld a,NEWLINE
	jr z,Decompress_EndOfBlock ; note: if offset = 0, 'adc' sets
				   ; the zero flag and resets carry
	xor a
	ld b,LENGTH_BITS	; Number of length bits can range from
				; 1 to 8.  3 bits with a bias of 5
				; (lengths 5 to 12) seems to be a good
				; choice for English text.
Decompress_LZLengthLoop:
	call GetBit
	rla
	djnz Decompress_LZLengthLoop
	add a,LENGTH_BIAS	; Length bias can be anything (but the
				; absolute maximum backreference
				; length is 255.)

	ld c,a			; B = 0 following DJNZ

	push de
	 ld de,(decompress_OutPtr)
	 ld a,e
	 sub l
	 ld l,a
	 ld a,d
	 sbc a,h
	 ld h,a
	 ldir
	 ld (decompress_OutPtr),de
	 pop de
	jr Decompress_Loop

GetBit:
	sla d
	ret nz
 .ifndef MULTI_PAGE_BLOCKS
	ld d,(ix)
	inc ix
	rl d			; carry was set by the SLA
	ret
 .else
	ld d,(ix)
	inc ix
	rl d			; carry was set by the SLA
	inc e
	ret nz
	push af
	 push ix		; don't use 'LD A,IXH' here --
	  pop af		; the nspire doesn't support
				; undocumented instructions!
	 add a,a
	 jr c,GetBit_NextPage
	 pop af
	ret
GetBit_NextPage:
	 in a,(6)
  .ifdef TI73
	 inc a
  .else
	 dec a
  .endif
	 out (6),a
	 ld ix,4000h
	 pop af
	ret
 .endif

	.rorg $$

DecompCodeSize .equ $ - DecompCode


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;; This is the Flashbook header.  The order of fields is important
;;; and needs to be kept synchronized with fb_book_read_app() and
;;; fb_book_write_app().  Please, if you modify this structure (or any
;;; of the table structures), change the identifying string to
;;; something other than 'FBebk'.

;;; Note that anything placed after the header will be overwritten by
;;; fb_book_write_app().

fbheader:
	.db "FBebk1"
fbFlags:
	.dw 0
fbBaseCharset:
	.db BASE_CHARSET
fbFontHeight:
	.db FONT_HEIGHT
fbMaxBlockSize:
	.dw BLOCK_SIZE
fbTitle:
	.dw 0
fbNumBlocks:
	.dw 0
fbBlockTable:
	.dw 0
fbFontTable:
	.dw 0
fbMappingTable:
	.dw 0
fbSectionTable:
	.dw 0
fbImageTable:
	.dw 0
fbCompressionData:
	.db OFFSET_BITS, LENGTH_BITS, LENGTH_BIAS
	;; Huffman tree...

