/*
 * Flashbook GUI
 * Copyright (c) 2008 Benjamin Moody
 *
 * This program is free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

typedef struct _fbeditwindow {
  char* filename;
  char* displayname;
  char* booktitle;
  char* appname;
  char* fontfile;
  char* hyphlang;
  fbsize blocksize;
  gboolean hyphenate;

  GtkWidget* textedit;
  GtkWidget* window;
  GtkWidget* toolbar;
  GtkWidget* status;
  GtkWidget* mainbox;
  GtkWidget* preview;
  GtkWidget* previewpane;
  guint scid_menu_hint;
  guint scid_text_info;
  guint smid_text_info;
  GtkTextBuffer* textbuf;
  GtkTextTag* tag_section;
  GtkAction* action_undo;
  GtkAction* action_redo;
  GtkAction* action_cut;
  GtkAction* action_copy;
  GtkAction* action_delete;
  gchar* error_log;
  int nerrors;
  int previewerror;

  GtkWidget* dlg_build;
  GtkWidget* dlg_search;

  struct _fbeditwindow* mdiprev;
  struct _fbeditwindow* mdinext;
} fbeditwindow;

void clear_fb_errors(fbeditwindow* ew);
int display_fb_error(fbeditwindow* ew, int errnum);
void display_io_error(GtkWidget* parent, const gchar* fname,
		      gboolean reading, int num);
fbbook* create_fb_from_edit(fbeditwindow* ew, gboolean ignore_err);

void run_builder_dialog(fbeditwindow* ew);

void start_search_dialog(fbeditwindow* ew);

gchar* detect_text_encoding(const gchar* input, gsize length);
void format_imported_text(gchar* buf, gboolean unwrap);
gboolean import_text_file(fbeditwindow* ew, const gchar* fname, gboolean replace);
