/*
 * Flashbook GUI
 * Copyright (c) 2008 Benjamin Moody
 *
 * This program is free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _FB_PREVIEW_H
#define _FB_PREVIEW_H

/* FBEditPreview class */

#define FB_TYPE_PREVIEW            (fb_preview_get_type())
#define FB_PREVIEW(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), FB_TYPE_PREVIEW, FBPreview))
#define FB_PREVIEW_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass), FB_TYPE_PREVIEW, FBPreviewClass))
#define FB_IS_PREVIEW(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FB_TYPE_PREVIEW))
#define FB_IS_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FB_TYPE_PREVIEW))
#define FB_PREVIEW_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), FB_TYPE_PREVIEW, FBPreviewClass))

typedef struct _FBPreview FBPreview;
typedef struct _FBPreviewClass FBPreviewClass;

typedef fbbook * (*FBPreviewRefreshFunc)(gpointer data);

struct _FBPreview {
  GtkWidget parent;

  GtkAdjustment *hadjustment;
  GtkAdjustment *vadjustment;

  GdkPixmap *fontbitmap;

  FBPreviewRefreshFunc refresh;
  gpointer refresh_data;

  fbbook *fb;
  gboolean need_refresh;

  GtkComboBox *combobox;
  gboolean setadjust;
};

struct _FBPreviewClass {
  GtkWidgetClass parent_class;

  void (*set_scroll_adjustments)(FBPreview *preview,
				 GtkAdjustment *hadj,
				 GtkAdjustment *vadj);
};

GType fb_preview_get_type(void) G_GNUC_CONST;

GtkWidget* fb_preview_new(FBPreviewRefreshFunc fnc, gpointer data);
void fb_preview_refresh(FBPreview* preview);
GtkWidget* fb_preview_box_new(FBPreviewRefreshFunc fnc, gpointer data,
			      GtkWidget** preview_widget);

#endif
