/*
 * libflashbook - Library for creating eBooks for the TI-83/84 Plus
 * Copyright (c) 2008 Benjamin Moody
 *
 * This program is free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#define LZ_MARKER ((fbchar) 0)

#define LZ_OFFSET_BITS (comp->lz_offset_bits)
#define LZ_OFFSET_BIAS (0)
#define LZ_LENGTH_BITS (comp->lz_length_bits)
#define LZ_LENGTH_BIAS (comp->lz_length_bias)

#define LZ_PARAM_BITS (LZ_LENGTH_BITS + LZ_OFFSET_BITS)
#define LZ_PARAM_BYTES ((LZ_PARAM_BITS + 7) / 8) /* used internally */

#define MIN_LZ_LENGTH LZ_LENGTH_BIAS
#define MAX_LZ_LENGTH (LZ_LENGTH_BIAS + (1 << LZ_LENGTH_BITS) - 1)
#define MIN_LZ_OFFSET (LZ_OFFSET_BIAS + 1)
#define MAX_LZ_OFFSET ((fbsize) LZ_OFFSET_BIAS + (1 << LZ_OFFSET_BITS) - 1)

#define LZ_VALUE(ooo, lll) (((lll) - LZ_LENGTH_BIAS) |                  \
                            (((ooo) - LZ_OFFSET_BIAS) << LZ_LENGTH_BITS))

#define LZ_LENGTH_MASK ((1 << LZ_LENGTH_BITS) - 1)
#define LZ_OFFSET_MASK (((1 << LZ_OFFSET_BITS) - 1) << LZ_LENGTH_BITS)

#define LZ_LENGTH(vvv) (((vvv) & LZ_LENGTH_MASK) + LZ_LENGTH_BIAS)
#define LZ_OFFSET(vvv) ((((vvv) & LZ_OFFSET_MASK) >> LZ_LENGTH_BITS) + LZ_OFFSET_BIAS)
